/*******************************************************************/
/* Excercise 1                                                     */
/*******************************************************************/
%let NObs = 1000;
%let min  = -40;
%let max  =  40;
%let seed = 123456;

/*******************************************************************/
/* Part 1 - use DATA step to create table                          */
/*******************************************************************/
data dsDegC (keep=degC) 
     dsAvgC (keep=avgC)
        ;
		label degC = 'Temperature in CelsiusTemp in Celsius';
		label avgC = 'Average Temperature in CelsiusTemp in Celsius' ;
		format degC F3.;
		format avgC F5.2;
		call streaminit(&seed);
		Min = &min; Max = &max; nObs = &NObs;
		sum = 0;
		do obs = 1 to nObs;
		   u = rand("Uniform");               /* U[0,1] */
		   degC = min + floor((1+Max-Min)*u); /* uniform integer in Min..Max */
		   output dsDegC;
		   sum = sum + degC;
		end;
		avgC = sum / (obs-1);
		output dsAvgC;
run;

/*******************************************************************/
/* Part 2 - use DS2 to create table                                */
/*******************************************************************/

/* a DS2 equivalent     */

/* two parts to change  */
/* 1. method run();     */
/* 2. declare int       */

proc DS2 scond=error;
data ds2DegC (keep=(degC)) 
     ds2AvgC (keep=(avgC))
     ;
	declare integer degC having label 'Temperature in CelsiusTemp in Celsius'      format F3.;  
	declare double  avgC having label 'Average Temperature in  Celsius' format F5.2; ;
/* 1. method run();     */
	method ^^^();  
    /*     ^^^   */

/* 2. declare int       */
	    ^^^^^^^ int min max obs nObs;  
    /*  ^^^^^^^  */
	    declare double u sum;
	    streaminit(&seed);
		  Min = &min; Max = &max; nObs = &NObs;
		  sum = 0;
		  do obs = 1 to nObs;
	       u = rand('UNIFORM');    
	       degC = min + floor((1+Max-Min)*u); /* uniform integer in Min..Max */
	       output ds2DegC ;
	       sum = sum + degC;
	    end;
	    avgC = sum / (obs-1);
	    output ds2AvgC;
	end;
enddata;	
run;
quit;


proc compare base=dsdegc compare=ds2degc; run;
