/*******************************************************************/
/* Excercise 2                                                     */
/*******************************************************************/
/*******************************************************************/
/**add method init() and method term()                            **/
/*******************************************************************/

/* two parts to change   */
/* 1. method init();     */
/* 2. method term();     */

proc DS2 ;
data ds2DegC (keep=(degC) )
     ds2AvgC (keep=(avgC) )
     ;
declare integer degC having label 'Temperature in CelsiusTemp in Celsius'  format F3.;
declare double  avgC having label 'Average Temperature in Celsius'         format F5.2;
declare integer min max nobs; 
declare double sum;
retain  sum nobs;
/* init method automaticall called one time */
/* 1. method init();     */
method ^^^^(); 
/*     ^^^^   */
    streaminit(&seed);
    Min = &min; Max = &max;
    nobs = &NObs;
    sum = 0;
end;

method run();
    declare double u;
    declare int obs;
    do obs = 1 to nobs;
       u = rand('UNIFORM');    
       degC = min + floor((1+Max-Min)*u); /* uniform integer in Min..Max */
       output ds2DegC;
       sum = sum + degC;
    end;
end;

/* term method automatically called one time */
/* 2. method term();     */
method ^^^^();  
/*     ^^^^   */
    avgC = sum / nobs;
    output ds2AvgC;
end;

enddata;	
run;
quit;
/********************************************************************************/
/********************************************************************************/
/** DID YOU GET AN ERROR??                                                      */
/********************************************************************************/
/********************************************************************************/


/* two parts to change               */
/* overwrite=YES  on each data set   */
proc DS2 ;
data ds2DegC (keep=(degC) ^^^^^^^^^-^^^)
              /*          ^^^^^^^^^=^^^   */
     ds2AvgC (keep=(avgC) ^^^^^^^^^-^^^)
              /*          ^^^^^^^^^=^^^   */
     ;
declare integer degC having label 'Temperature in CelsiusTemp in Celsius'  format F3.;
declare double  avgC having label 'Average Temperature in Celsius'         format F5.2;
declare integer min max nobs; 
declare double sum;
retain  sum nobs;

method init(); 
    streaminit(&seed);
    Min = &min; Max = &max;
    nobs = &NObs;
    sum = 0;
end;

method run();
    declare double u;
    declare int obs;
    do obs = 1 to nobs;
       u = rand('UNIFORM');    
       degC = min + floor((1+Max-Min)*u); /* uniform integer in Min..Max */
       output ds2DegC;
       sum = sum + degC;
    end;
end;

method term();  
    avgC = sum / nobs;
    output ds2AvgC;
end;

enddata;	
run;
quit;

/********************************************************************************/
/********************************************************************************/
/** DS2 does not automatically overwrite tables                                **/
/** you must tell it to overwrite with the OVERWRITE=YES dataset option        **/
/********************************************************************************/
/********************************************************************************/
