/*******************************************************************/
/* Excercise 3                                                     */
/*******************************************************************/
/*******************************************************************/
/**add a user defined method c_to_f                               **/
/**create a table with degC and degF                              **/
/**from 0c to 100c                                                **/
/*******************************************************************/

/*******************************************************************/
/* Part 1 - the data step                                          */
/*          no changes needed,simply run the step                  */
/*******************************************************************/
data dsDegCF (keep=degC degF);
format degC 3.
       degF 6.1
       ;
label degC = 'Temperature in Celsius'
      degF = 'Temperature in Fahrenheit'      
      ;
    do degC = 0 to 100;
        degF = 32 + (degC *  (9 / 5));
        output;
    end;
run;

/*******************************************************************/
/* Part 2 - DS2 the data step                                      */
/*******************************************************************/
/* two parts to change         */
/* 1. method c_to_f;           */
/* 2. degF = c_to_f(degC);     */
proc DS2 ;
data ds2DegCF (keep=(degC degF) overwrite=YES)
     ;
declare integer degC having label 'Temperature in Celsius'         format F3.;
declare double  degF having label 'Temperature in Fahrenheit'      format F6.1;;

/* 1. method c_to_f;           */
   method c_to_f(integer C) returns double;
/* ^^^^^^ ^^^^^^ */
       return(32 + (C *  (9 / 5))); /* uniform integer in Min..Max */
end;


method run();
    declare int i;
    do degC = 0 to 100;
/* 2. degF = c_to_f(degC);     */
        degF = c_to_f(degC);  
/*      degF = ^^^^^^(degF);   */
        output ;
    end;
end;

enddata;	
run;
quit;

/* compare results  */
proc compare base=dsDegCF compare=ds2DegCF;run;


/*******************************************************************/
/* Part 3 - DS2 the data step                                      */
/*******************************************************************/
/**************************************/
/* one part to change                 */
/* 1. return(32 + (C *  (9. / 5.)));  */
/**************************************/
proc DS2 ;
data ds2DegCF (keep=(degC degF) overwrite=YES)
     ;
declare integer degC having label 'Temperature in Celsius'         format 3.;
declare double  degF having label 'Temperature in Fahrenheit'      format 6.1;;

method c_to_f(integer C) returns double;
/* 1. return(32 + (C *  (9. / 5.)));  */
       return(32 + (C *  (^^^^^^^))); /* uniform integer in Min..Max */
/*                       (^^^^^^^)));  */
end;


method run();
    declare int i;
    do degC = 0 to 100;
        degF = c_to_f(degC);  
        output ;
    end;
end;

enddata;	
run;
quit;

/* compare results  */
proc compare base=dsDegCF compare=ds2DegCF;run;

/******************************************************************************/
/* note the format difference. in data step we have 3. and in DS2 we have F3. */
/* the format F3. and F6.1 are valid in the data step.                        */
/* if you change the format in the data step program and re-run               */
/*   the diffences will disappear                                             */
/******************************************************************************/

