/*******************************************************************/
/* Exercise 7                                                      */
/*******************************************************************/

/*******************************************************************/
/* DS2 package to sum numbers and output average                   */
/*******************************************************************/

/************************************************/
/* four parts to change                         */
/* 1. default constructor: method accumulate(); */
/* 2. method add(numeric(10,2) inAmt);          */
/* 3. method getAmt() returns numeric(10,2);    */
/* 4. method getAvg() returns numeric(10,2);    */
/************************************************/

/*******************************************************************/
/* create a package                                                */
/*   package has more functionality than needed                    */
/*******************************************************************/
proc ds2;

package packlib.accumulate / overwrite = yes;
declare integer cnt;	 
declare numeric(10,2) amt;

/* default constructor                                             */

/* 1. default constructor: method accumulate(); */
method accumulate();		
/*     ^^^^^^^^^^();  */
    cnt = 0;
    amt = 0.00;
end;

/* constructor with initial amount                                 */
method accumulate(numeric(10,2) inAmt);		
    accumulate();				 
    if inAmt > 0.00 				
    then
      do;
        cnt = 1;
        amt = inAmt;
      end;
end;

/* constructor with initial amount  and count                      */
method accumulate(integer inCnt, numeric(10,2) inAmt);	 
       accumulate();
       cnt = inCnt;
       amt = inAmt;
end;

/* initial add method                           */
/* 2. method add(numeric(10,2) inAmt);          */
method add(numeric(10,2) inAmt);	
/*     ^^^                                      */
    cnt = cnt + 1;
    amt = amt + inAmt;
end;

/* set methods to set count or amount            */
method setcnt(integer inCnt);		
    if (cnt = 0)  then cnt = inCnt; 
end;

method setamt(numeric(10,2) inAmt);	
    if (amt = 0.00) then amt = inAmt;
end;

/* get methods to get count or amount           */
method getCnt() returns integer;		
    return (cnt); 
end;

/* 3. method getAmt() returns numeric(10,2);    */
method getAmt() returns numeric(10,2);	
/*     ^^^^^^()                                 */
    return (amt); 
end;

/* 4. method getAvg() returns numeric(10,2);    */
method getAvg() returns numeric(10,2);	
/*     ^^^^^^()                                 */
    return (amt/cnt); 
end;

endpackage;
run;
quit;

/*******************************************************************/
/* our DS2 program using the package                               */
/*******************************************************************/
/************************************************/
/* two parts to change                          */
/* 1. fees.add(amount);                         */
/* 2. avgAmt = fees.getAvg();                   */
/************************************************/

proc ds2;
data acc (overwrite=yes);
declare package packlib.accumulate fees();
declare numeric(10,2) total avgAmt having format comma15.2;	 
drop amount;

method run();
    set amounts;
/* 1. fees.add(amount);                         */
    fees.add(amount); 	
/*  fees.^^^(amount);                           */
end;

method term();
  total  = fees.getamt(); 
/* 2. avgAmt = fees.getAvg();                   */

  avgAmt = fees.getAvg();	
/*         ^^^^.getAvg();                       */
  output;
end;
enddata;
run;
quit;

