/*******************************************************************/
/* Exercise 8                                                      */
/*******************************************************************/

/*******************************************************************/
/* add min and max to data step                                    */
/* no changes needed in data step, run as is                       */
/*******************************************************************/
DATA summaryAmts;
	retain total max min 0;	
    format avgAmt 8.2;
	drop amount;
	set amounts end = done;
	if _n_ = 1 then
	do;
	   min = amount; max = amount;
	end;
    total = total + amount;
	if amount < min then min = amount;	
	if amount > max then max = amount;	
  if done then
	do;
       avgAmt = total / _n_;
	   output;
	end;
run;


/*******************************************************************/
/* DS2 package to sum numbers and output average, min & max        */
/*******************************************************************/

/************************************************/
/* three parts to change                        */
/* 1. declare numeric(10,2) amt min max ;       */
/* 2. min = 99999999.99;                        */
/* 3. return (min);                             */
/************************************************/

/*******************************************************************/
/* create a package                                                */
/*   package has more functionality than needed                    */
/*   update package to get min and max                             */
/*******************************************************************/
proc ds2;

package packlib.accumulate / overwrite = yes;
declare integer cnt;	 
/* 1. declare numeric(10,2) amt min max ;       */
    declare numeric(10,2) amt min max ; 
/*  declare numeric(10,2) amt ^^^ ^^^ ;         */

/* default constructor   == UPDATED                               */
method accumulate();
    cnt = 0;
    amt = 0.00;
/* 2. min = 99999999.99;                        */
    min = 99999999.99;
/*  ^^^ = 999999999.99                          */
    max = 0.00;
end;

/* no change to other constructors                               */
method accumulate(numeric(10,2) inAmt);		
    accumulate();				 
    if inAmt > 0.00 				
    then
      do;
        cnt = 1;
        amt = inAmt;
      end;
end;

method accumulate(integer inCnt, numeric(10,2) inAmt);	 
       accumulate();
       cnt = inCnt;
       amt = inAmt;
end;

/* add method       == UPDATED                               */
method add(numeric(10,2) inAmt);
    cnt = cnt + 1;
    amt = amt + inAmt;
    if      inAmt > max then max = inAmt;
    else if inAmt < min then min = inAmt;
end;

method setcnt(integer inCnt);		
    if (cnt = 0)  then cnt = inCnt; 
end;

method setamt(numeric(10,2) inAmt);	
    if (amt = 0.00) then amt = inAmt;
end;

/* new get methods for min and max                        */
method getCnt() returns integer;		
    return (cnt); 
end;

method getAmt() returns numeric(10,2);	
    return (amt); 
end;

method getAvg() returns numeric(10,2);	
    return (amt/cnt); 
end;

method getMin() returns numeric(10,2);	
/* 3. return (min);                             */
    return (min); 
/*  return (^^^);                               */
end;

method getMax() returns numeric(10,2);
    return (max); 
end;

endpackage;
run;
quit;

/*******************************************************************/
/* our DS2 program using the package                               */
/*  note we only had to make two changes:                          */
/*   1. add min and max to DECLARE statement                       */
/*   2. add the get methods in term()                              */
/*******************************************************************/

/************************************************/
/* three parts to change                        */
/* 1. declare numeric(10,2) amt min max ;       */
/* 2. max = fees.getMAX();                      */
/************************************************/

proc ds2;
data acc2 (overwrite=yes);
declare package packlib.accumulate fees();
/* 1. declare numeric(10,2) amt min max ;       */
   declare numeric(10,2) total avgAmt min max having format comma15.2;	 
/* declare numeric(10,2) total avgAmt ^^^ ^^^ having format comma15.2; */

drop amount;

method run();
    set amounts;
    fees.add(amount); 	
end;

method term();
  total = fees.getamt(); 
  avgAmt = fees.getAvg(); 
  min = fees.getMin(); 

/* 2. max = fees.getMAX();                      */
  max = fees.getMAX();
/*MAX = ^^^^.^^^^^^()                           */

  output;
end;
enddata;
run;
quit;

